// ************ fe basis functions ******************
// ************ fe basis functions ******************
// ************ fe basis functions ******************

void line2(double eta, double psi[2], double dpsi[2])
{
  psi[0] = (1-eta)/2.0; dpsi[0] = -0.5;    // piecewise linear
  psi[1] = (1+eta)/2.0; dpsi[1] =  0.5;

  return;
}

void line2(double eta, double psi[2], svector<1> dpsi[2])
{
  psi[0] = (1-eta)/2.0; dpsi[0] = -0.5;    // piecewise linear
  psi[1] = (1+eta)/2.0; dpsi[1] =  0.5;

  return;
}

void line3(double eta, double psi[3], double dpsi[3])
{
 double ope = 1+eta, ome = 1-eta;

 psi[0] = -eta * ome / 2; dpsi[0] = -0.5 + eta;
 psi[1] =  eta * ope / 2; dpsi[1] =  0.5 + eta;
 psi[2] =  ope * ome    ; dpsi[2] = -2.0 * eta;

return;
}

void line3(double eta, double psi[3], svector<1> dpsi[3])
{
 double ope = 1+eta, ome = 1-eta;

 psi[0] = -eta * ome / 2; dpsi[0] = -0.5 + eta;
 psi[1] =  eta * ope / 2; dpsi[1] =  0.5 + eta;
 psi[2] =  ope * ome    ; dpsi[2] = -2.0 * eta;

return;
}


void tri3(svector<2> xi, double sn[], svector<2> dsn[])
{
  double eta = xi[0], ata = xi[1], omema = 1.0-eta-ata;

  sn[0] = omema;  dsn[0] = svector<2>(-1,-1);
  sn[1] = eta;    dsn[1] = svector<2>(1,0);
  sn[2] = ata;    dsn[2] = svector<2>(0,1);
}

void tri6(svector<2> xi, double sn[], svector<2> dsn[])
{
  double eta = xi[0], ata = xi[1], omema = 1.0-eta-ata, hmema = 0.5-eta-ata;

  sn[0] = 2*omema*hmema;
  sn[1] = 2* eta *(eta-0.5);
  sn[2] = 2* ata *(ata-0.5);

  sn[3] = 4*eta*omema;
  sn[4] = 4*eta*ata;
  sn[5] = 4*ata*omema;

  dsn[0] = -2*(hmema+omema) * svector<2>(1.0,1.0);
  dsn[1] = svector<2>(4*eta-1, 0.0);
  dsn[2] = svector<2>(0.0, 4*ata-1);

  dsn[3] = 4 * svector<2>(1-2*eta-ata, -eta);
  dsn[4] = 4 * svector<2>(ata,eta);
  dsn[5] = 4 * svector<2>(-ata, 1-eta-2*ata);

  return;
}

void tet4( const svector<3> xi, double phi[4] , svector<3> dphi[4])
{
double xi3 = 1 - xi[0] - xi[1] - xi[2];

phi[0] = xi3;    dphi[0] = svector<3>(-1,-1,-1);
phi[1] = xi[0];  dphi[1] = svector<3>( 1, 0, 0);
phi[2] = xi[1];  dphi[2] = svector<3>( 0, 1, 0);
phi[3] = xi[2];  dphi[3] = svector<3>( 0, 0, 1);

return;
}

void tet10(const svector<3> xi, double phi[10], svector<3> dphi[10])  
{
double eta[4];

eta[0] = 1 - xi[0] - xi[1] - xi[2];   // baracentric coordiates

dphi[0] = svector<3>(-1,-1,-1);
dphi[1] = svector<3>( 1, 0, 0);
dphi[2] = svector<3>( 0, 1, 0);
dphi[3] = svector<3>( 0, 0, 1);

for(int i = 0; i < 3; i++)   // mid sides (0,1) (1,2) (2,0)
  {
  eta[i+1] = xi[i];   // baracentric coordiates

  phi[4+i] = 4 * eta[i] * eta[(i+1)%3];

  dphi[4+i] = (4 * eta[(i+1)%3]) * dphi[i] + (4 * eta[i]) * dphi[(i+1)%3];
  }
 
for(int i = 0; i < 3; i++)   // mid sides (0,3) (1,3) (2,3)
  {
  phi[7+i] = 4 * eta[i] * eta[3];

  dphi[7+i] = (4 * eta[3]) * dphi[i] + (4 * eta[i]) * dphi[3];
  }

for(int i = 0; i < 4; i++)   // vetriex basis functions
  {
  phi[i] = 2 * eta[i] * (eta[i] - 0.5);

  dphi[i] = (4 * eta[i] - 1) * dphi[i];
  }

return;
}
