void tri3(svector<2> xi, double phi[3], svector<2> dphi[3]);
void tet4(svector<3> xi, double phi[4], svector<3> dphi[4]);

// ******************** geoetric element ******************
// ******************** geoetric element ******************
// ******************** geoetric element ******************

struct masterElement
{
  int dim;               // dimension 1, 2, or 3 ...

  int nn;                // number of nodes, edges, faces, cells
  int ne;
  int nf;
  int nc;

  int nne;               // number of nodes per edge
  int nnf;               // number of nodes per face
  int nnc;               // number of nodes per cell

  int edges[6][2];   
  int faces[4][3];
  int cells[1][4];

  void (*basis)(svector<3>, double *phi, svector<3> *dphi);
};

masterElement LinearTetrahedron = 
  {3, 
   4,6,4,1,
   2,3,4, 
   {{0,1}, {1,2}, {2,0}, {3,0}, {3,1}, {3,2}}, 
   {{0,2,1}, {0,1,3}, {1,2,3}, {0,3,2}},
   {{0,1,2,3}},
   tet4};

class gelement
{
public:
    int type;    // currently unused
    int nodes[4];
    svector<3> xx[4];

    void print(ostream &);
    
    masterElement *master;
};

void gelement::print(ostream &out = cout)
{
  int j;

  out.setf(ios::fixed,ios::floatfield);

  out << "Vertex  id's: ";
  for(j = 0; j < 4; j++) out << " " << setw(3) << nodes[j];
  out << endl;

  for(j = 0; j < 2; j++) 
    out << " (" << xx[j][0] << "," << xx[j][1] << "," << xx[j][2] << ")";

  out << endl;

  for(j = 2; j < 4; j++) 
    out << " (" << xx[j][0] << "," << xx[j][1] << "," << xx[j][2] << ")";

  out << endl;

  return;
}

// ******************** boundary geoetric element ******************
// ******************** boundary geoetric element ******************
// ******************** boundary geoetric element ******************

struct masterBelement
{
  int dim;               // dimension 1, 2, or 3 ...

  int nn;                // number of nodes, edges, faces
  int ne;
  int nf;

  int nne;               // number of nodes per edge
  int nnf;               // number of nodes per face

  int edges[3][2];
  int faces[1][3];

  void (*basis)(bvector xi, double *phi, bvector *dphi);
};

masterBelement LinearTriangle = 
  {2, 
   3,3,1, 
   2,3, 
   {{0,1},{1,2},{2,0}}, 
   {{0,1,2}},
   tri3};

class bgelement
{
public:
 int bctype;
 int nodes[3];
 svector<3> xx[3];

 void print(ostream &);

 masterBelement *master;
};

void bgelement::print(ostream &out = cout)
{
  int j;

  //  out << "gelement::print()" << endl;

  out.setf(ios::fixed,ios::floatfield);

  for(j = 0; j < 3; j++) out << " " << setw(3) << nodes[j];
  out << endl;

  for(j = 0; j < 3; j++) 
    {
      out << " (";
      out.precision(4);
      out <<  xx[j][0] << ",";
      out.precision(4);
      out << xx[j][1] << ",";
      out.precision(4);
      out << xx[j][2] << ")";
    }
  out << endl;
}

// The declaration vector<int[Nvar] > is illegal, 
// so use vector<intArray<Nvar> >

template<const int Nsize>
class intArray
{
 public:
  intArray() {return;}
  
  operator int*() {return ii;}
  operator const int*() const {return ii;}  // for use in const expressions
  
 private:
  int ii[Nsize];
};

