// Examples for the 2d Poisson Code
// Examples for the 2d Poisson Code
// Examples for the 2d Poisson Code

// Solution of Laplaces's equation (f = 0)

void initialize0(void) {}

double exact0(dvector xx, dvector& dudx)
{
 double u,pix,cos_pix,e_piy;

 const double pi = 3.1415926535897932;     

 pix     = pi * xx[0];
 cos_pix = cos(pix);
 e_piy   = exp(pi * xx[1]);

 u = cos_pix * e_piy;

 dudx = dvector(-pi * sin(pix) * e_piy, pi * u);

 return(u);
}

void coeff0(dvector xx, dmatrix& aa, double &b)
{
  aa.identity();
  b = 0.0;

  return;
}

double rhs0(dvector xx)
{
 return(0.0);
}

// Solution of Poisson's equation (f = -6)

void initialize1(void) {}

double exact1(dvector xx, dvector& dudx)
{
  double u = xx[0]*xx[0] + 2*xx[1]*xx[1];

  dudx = dvector(2*xx[0], 4*xx[1], 0.0);

 return(u);
}

void coeff1(dvector xx, dmatrix& aa, double &b)
{
  aa.identity();
  b = 0.0;

  return;
}

double rhs1(dvector xx)
{
 return(-6.0);
}
