// Examples for the 3d Poisson Code
// Examples for the 3d Poisson Code
// Examples for the 3d Poisson Code


// Solution of Laplace's equation (f=0)

void initialize0(void) {}

double exact0(dvector xx, dvector& dudx)  
{
 double u,pix,cos_pix,e_piy;

 const double pi = 3.1415926535897932;     

 double sqrt2 = sqrt(2.0), piz, sin_piz;

 pix     = pi * xx[0] / sqrt2;
 cos_pix = cos(pix);
 e_piy   = exp(pi * xx[1]);
 piz     = pi * xx[2] / sqrt2;
 sin_piz = sin(piz);

 u = cos_pix * e_piy * sin_piz;

 dudx = dvector((-pi/sqrt2) * sin(pix) * e_piy * sin_piz, 
		pi * u, 
		(pi/sqrt2) * cos_pix * e_piy * cos(piz)); 

 return(u);
}

void coeff0(dvector xx, dmatrix& aa, double &b)
{
  aa.identity();
  b = 0.0;

  return;
}

double rhs0(dvector xx)
{
 return(0.0);
}

// Solution of Poisson's equation (f = -6)

void initialize1(void) {}

double exact1(dvector xx, dvector& dudx)
{
  double u = xx[0]*xx[0] + 2*xx[1]*xx[1];

  dudx = dvector(2*xx[0], 4*xx[1], 0.0);

 return(u);
}

void coeff1(dvector xx, dmatrix& aa, double &b)
{
  aa.identity();
  b = 0.0;

  return;
}

double rhs1(dvector xx)
{
 return(-6.0);
}
